<%@page import="java.util.*,javax.naming.*,javax.sql.DataSource,java.sql.*"%>
<h1>JNDI Datasource lookup test</h1>
<%
    // This verifies that the context java:comp/env is configured properly, after complete context initialization
    Map<String, DataSource> globalmap = new HashMap<String, DataSource>();
    Connection con = null;
    DataSource dataSourceGlobal = null;
    DataSource dataSourceComp = null;
    try {
        Context initCtx = new InitialContext();
        Context envCtxComp = (Context) initCtx.lookup("java:comp/env");
        dataSourceComp = (DataSource) envCtxComp.lookup("jdbc/ExampleDS");
        if (dataSourceComp != null)
        {
            globalmap.put("java:comp/env/jdbc/ExampleDS", dataSourceComp);
            try {
	            con = dataSourceComp.getConnection();
            } catch (Throwable e) {
                out.println("Exception thrown: " + e.getMessage());
                int tryLimit = 5;
                while (e.getCause() != null && tryLimit > 0)
                {
                    e = e.getCause();
                    tryLimit--;
                }
                e.printStackTrace();
            } finally {
                if (con != null) {
                    con.close();
                }
            }
        }
        else
        {
            out.println("dataSourceComp java:comp/env lookup was null");
        }
        Context envCtxGlobal = (Context) initCtx.lookup("java:jboss");
        dataSourceGlobal = (DataSource) envCtxGlobal.lookup("datasources/ExampleDS");
        if (dataSourceGlobal != null)
        {
            globalmap.put("java:jboss/datasources/ExampleDS", dataSourceGlobal);
            try {
                con = dataSourceGlobal.getConnection();
            } catch (Throwable e) {
                out.println("Exception thrown: " + e.getMessage());
                int tryLimit = 5;
                while (e.getCause() != null && tryLimit > 0)
                {
                    e = e.getCause();
                    tryLimit--;
                }
                e.printStackTrace();
            } finally {
                if (con != null) {
                    con.close();
                }
            }
        }
        else
        {
            out.println("dataSourceGlobal java:/datasources was null");
        }
    } catch (Throwable e) {
        out.println("Exception thrown: " + e.getMessage());
        int tryLimit = 5;
        while (e.getCause() != null && tryLimit > 0)
        {
            e = e.getCause();
            tryLimit--;
        }
        e.printStackTrace();
    }
%>

<table>
<tr><th>Bean Name</th><th>Bean Value</th></tr>
<% for (Map.Entry<String, DataSource> e: globalmap.entrySet()) { %>
<tr><td><%=e.getKey()%></td><td><%=e.getValue()%></td></tr>
<% } %>
</table>
